Opened 22 months ago

Last modified 2 months ago

#4745 reopened

3G & 4G Broadband Modems broken in r25948 and later

Reported by: uruiamme Owned by:
Keywords: 3g mobile broadband wan ppp pppd ifconfig Cc:

Description

3G Modems were broken between r25760 (works) and r25948 (broke). I think it has something to do with some changes made to pppd or to network.c. Please see if this fixes it. It is basically an ifconfig command, and whether it works or not, it shouldn't break anything except 3G modem testers.

I have confirmed that the same thing happens to me as it does to this person: http://www.dd-wrt.com/phpBB2/viewtopic.php?p=951505&highlight=modem+beta#951505

Here is the diffs compiled by KrypteX at http://www.dd-wrt.com/phpBB2/viewtopic.php?t=279466

Please note that there was a kernel update, too.

=> 25948 ----- 2015/01/17 ------------------------------------------------------------------------------
[916] Upd: Kernel 3.10.65-rc1, 3.18.3-rc1
[889] Upd: DNSMasq 2.73test4
[947] Fix: [Ralink] WiFi LED On/Off http://svn.dd-wrt.com/ticket/3369
[940-941] Fix: Mounted USB drive corruption after reboot http://svn.dd-wrt.com/ticket/3927
[916,928-931] Fix: [K3.10,K3.18] ath9k WiFi dropouts/freezes http://svn.dd-wrt.com/ticket/2952

=> 25887 ----- 2015/01/13 (nightly) --------------------------------------------------------------------
[763,765,773,816,886] Upd: Kernel 3.2.66, 3.10.64, 3.14.28, 3.18.2, 3.19-rc4
[887] Upd: pppd 2.4.7
[767] Fix: [WNDR3700/WNDR3800] Dedicated WiFi On/Off button http://svn.dd-wrt.com/ticket/3369
[766]*Fix: [Ralink] WPS Radio On/Off http://svn.dd-wrt.com/ticket/3369
[770-771]*Fix: [Ralink] Net isolation option http://svn.dd-wrt.com/ticket/3563
[813,815]*Fix: [Ralink] HT40 side channel broadcast http://svn.dd-wrt.com/ticket/3880

=> 25760 ----- 2015/01/04 ------------------------------------------------------------------------------

My Proposed fix. Number 1. Note that this is a bit of a kluge, but I am wondering if it will fix it barring a more detailed rewrite of the code based on what may have broken. I am not a C programmer, just a hacker.

Add this line

 ifconfig(wan_ifname, IFUP, NULL, NULL);	// Bring up the ppp0 interface for 3G

to network.c (see http://svn.dd-wrt.com/browser/src/router/services/networking/network.c?rev=25855#L3277 )

Somewhere in this section (lines 3277 to 3283):

#ifdef HAVE_3G
	        if ((strcmp(wan_proto, "3g") == 0)) {
	                if (!nvram_match("usb_enable", "1")) {
	                        nvram_set("usb_enable", "1");   //  simply enable it, otherwise 3g might not work
	                        nvram_commit();
	                        start_drivers();
	                }
					

Like this:

#ifdef HAVE_3G
			ifconfig(wan_ifname, IFUP, NULL, NULL);		// Bring up the ppp0 interface for 3G
	        if ((strcmp(wan_proto, "3g") == 0)) {
	                if (!nvram_match("usb_enable", "1")) {
	                        nvram_set("usb_enable", "1");   //  simply enable it, otherwise 3g might not work
	                        nvram_commit();
	                        start_drivers();
	                }
					

Attachments (1)

part_of_log.txt (15.2 KB) - added by Mile-Lile 2 months ago.

Download all attachments as: .zip

Change History (20)

comment:1 Changed 22 months ago by ashokjp

I am also having same issues

My Router is TP-Link MR3020, Modem -> ZTE AC2746, ZTE AC2766

Everything working fine till build -> 25760 3G Modem not connecting after that, all builds till date

Details -> refer topic http://www.dd-wrt.com/phpBB2/viewtopic.php?t=279162

I am also attaching a log from SERIAL UART

U-Boot 1.1.4-ge28c8345 (Jun 10 2014 - 17:57:43) 

AP121 (ar9330) U-boot 

DRAM:  32 MB 
led turning on for 1s... 
id read 0x100000ff 
flash size 4194304, sector count = 64 
Flash:  4 MB 
Using default environment 

In:    serial 
Out:   serial 
Err:   serial 
Net:   ag7240_enet_initialize... 
No valid address in Flash. Using fixed address 
No valid address in Flash. Using fixed address 
: cfg1 0x5 cfg2 0x7114 
eth0: 00:03:7f:09:0b:ad 
ag7240_phy_setup 
eth0 up 
: cfg1 0xf cfg2 0x7214 
eth1: 00:03:7f:09:0b:ad 
athrs26_reg_init_lan 
ATHRS26: resetting s26 
ATHRS26: s26 reset done 
ag7240_phy_setup 
eth1 up 
eth0, eth1 
auto update firmware: is_auto_upload_firmware = 0! 
eth0, eth1 
auto update firmware: is_auto_upload_firmware = 0! 
Autobooting in 1 seconds 
## Booting image at 9f020000 ... 
   Uncompressing Kernel Image ... OK 

Starting kernel ... 

AR9330 
detect mem size 
Uart Init 
Booting (Hornet)... 
start service 
starting Architecture code for hornet 
udevtrigger[203]: parse_config_file: can't open '/etc/udev/udev.conf' as config file: No such file or directory 
function start_hotplug_block not found 
function start_hotplug_block not found 
function start_hotplug_block not found 
function start_hotplug_block not found 
function start_hotplug_block not found 
function start_hotplug_block not found 
function start_hotplug_block not found 
sh: can't create /sys/class/net/lo/queues/rx-0/rps_cpus: nonexistent directory 
sh: can't create /sys/class/net/lo/queues/tx-0/xps_cpus: nonexistent directory 
load ATH Ethernet Driver 
function start_hotplug_block not found 
sh: can't create /sys/class/net/eth0/queues/rx-0/rps_cpus: nonexistent directory 
sh: can't create /sys/class/net/eth0/queues/tx-0/xps_cpus: nonexistent directory 
configure eth0 to e8:de:27:84:5d:60 
sh: can't create /sys/class/net/eth1/queues/rx-0/rps_cpus: nonexistent directory 
sh: configure eth1 to E8:DE:27:84:5D:61 
can't create /sys/class/net/eth1/queues/tx-0/xps_cpus: nonexistent directory 
load ATH 802.11 a/b/g Driver 
load ATH9K 802.11n Driver 
sh: can't create /sys/class/net/wlan0/queues/rx-0/rps_cpus: nonexistent directory 
sh: can't create /sys/class/net/wlan0/queues/tx-0/xps_cpus: nonexistent directory 
[USB] checking... 

ath9k deconfigure_single: phy0 ath0 
sh: can't create /sys/class/net/br0/queues/rx-0/rps_cpus: nonexistent directory 
sh: can't create /sys/class/net/br0/queues/tx-0/xps_cpus: nonexistent directory 
ath9k deconfigure_single: phy0 ath0 
ath9k configure_single: phy0 ath0 
sh: can't create /sys/class/net/ath0/queues/rx-0/rps_cpus: nonexistent directory 
call mac80211autochannel for interface: ath0 
sh: can't create /sys/class/net/ath0/queues/tx-0/xps_cpus: nonexistent directory 
freq:2412 qual:71 noise:-89 
freq:2417 qual:40 noise:-89 
freq:2422 qual:65 noise:-90 
freq:2427 qual:70 noise:-90 
freq:2432 qual:45 noise:-90 
freq:2437 qual:94 noise:-90 
freq:2442 qual:48 noise:-91 
freq:2447 qual:73 noise:-91 
freq:2452 qual:73 noise:-91 
freq:2457 qual:49 noise:-92 
freq:2462 qual:91 noise:-92 
freq:2467 qual:50 noise:-92 
freq:2472 qual:75 noise:-92 
mac80211autochannel interface: ath0 frequency: 2437 
setup ath0 E8:DE:27:84:5D:60 
sh: can't create /proc/sys/net/ipv4/netfilter/ip_conntrack_udp_timeouts: nonexistent directory 
No such device 
ZTE generic (cdrom) detected 
customsetup 
Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

Look for default devices ... 
   product ID matched 
 Found devices in default mode (1) 
Access device 002 on bus 001 
Current configuration number is 1 
Use interface number 0 
Use endpoints 0x0a (out) and 0x89 (in) 

USB description data (for identification) 
------------------------- 
Manufacturer: ZTE, Incorporated 
     Product: USB Storage 
  Serial No.: 000000000002 
------------------------- 
Looking for active driver ... 
 No active driver found. Detached before or never attached 
Set up interface 0 
Use endpoint 0x0a for message sending ... 
Trying to send message 1 to endpoint 0x0a ... 
 OK, message successfully sent 
Reset response endpoint 0x89 
Reset message endpoint 0x0a 
 Could not reset endpoint (probably harmless): -99 
 Device is gone, skip any further commands 
-> Run lsusb to note any changes. Bye! 

Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

ath9k radio 0: phy0 ath0 
sh: can't create /proc/sys/dev/wifi0/silent: nonexistent directory 
sh: can't create /proc/sys/dev/wifi0/ledon: nonexistent directory 
ath9k radio 1: phy0 ath0 
sh: can't create /proc/sys/dev/wifi0/silent: nonexistent directory 
/opt/etc/init.d/rcS: No such file or directory 
/jffs/etc/init.d/rcS: No such file or directory 
/mmc/etc/init.d/rcS: No such file or directory 
sh: can't create /proc/sys/net/ipv4/netfilter/ip_conntrack_udp_timeouts: nonexistent directory 
No such device 
ZTE generic (modem) detected 
U-Boot 1.1.4-ge28c8345 (Jun 10 2014 - 17:57:43) 

AP121 (ar9330) U-boot 

DRAM:  32 MB 
led turning on for 1s... 
id read 0x100000ff 
flash size 4194304, sector count = 64 
Flash:  4 MB 
Using default environment 

In:    serial 
Out:   serial 
Err:   serial 
Net:   ag7240_enet_initialize... 
No valid address in Flash. Using fixed address 
No valid address in Flash. Using fixed address 
: cfg1 0x5 cfg2 0x7114 
eth0: 00:03:7f:09:0b:ad 
ag7240_phy_setup 
eth0 up 
: cfg1 0xf cfg2 0x7214 
eth1: 00:03:7f:09:0b:ad 
athrs26_reg_init_lan 
ATHRS26: resetting s26 
ATHRS26: s26 reset done 
ag7240_phy_setup 
eth1 up 
eth0, eth1 
auto update firmware: is_auto_upload_firmware = 0! 
eth0, eth1 
auto update firmware: is_auto_upload_firmware = 0! 
Autobooting in 1 seconds 
## Booting image at 9f020000 ... 
   Uncompressing Kernel Image ... OK 

Starting kernel ... 

AR9330 
detect mem size 
Uart Init 
Booting (Hornet)... 
start service 
starting Architecture code for hornet 
udevtrigger[203]: parse_config_file: can't open '/etc/udev/udev.conf' as config file: No such file or directory 
function start_hotplug_block not found 
function start_hotplug_block not found 
function start_hotplug_block not found 
function start_hotplug_block not found 
function start_hotplug_block not found 
function start_hotplug_block not found 
function start_hotplug_block not found 
sh: can't create /sys/class/net/lo/queues/rx-0/rps_cpus: nonexistent directory 
sh: can't create /sys/class/net/lo/queues/tx-0/xps_cpus: nonexistent directory 
load ATH Ethernet Driver 
function start_hotplug_block not found 
sh: can't create /sys/class/net/eth0/queues/rx-0/rps_cpus: nonexistent directory 
sh: can't create /sys/class/net/eth0/queues/tx-0/xps_cpus: nonexistent directory 
configure eth0 to e8:de:27:84:5d:60 
sh: can't create /sys/class/net/eth1/queues/rx-0/rps_cpus: nonexistent directory 
sh: configure eth1 to E8:DE:27:84:5D:61 
can't create /sys/class/net/eth1/queues/tx-0/xps_cpus: nonexistent directory 
load ATH 802.11 a/b/g Driver 
load ATH9K 802.11n Driver 
sh: can't create /sys/class/net/wlan0/queues/rx-0/rps_cpus: nonexistent directory 
sh: can't create /sys/class/net/wlan0/queues/tx-0/xps_cpus: nonexistent directory 
[USB] checking... 

ath9k deconfigure_single: phy0 ath0 
sh: can't create /sys/class/net/br0/queues/rx-0/rps_cpus: nonexistent directory 
sh: can't create /sys/class/net/br0/queues/tx-0/xps_cpus: nonexistent directory 
ath9k deconfigure_single: phy0 ath0 
ath9k configure_single: phy0 ath0 
sh: can't create /sys/class/net/ath0/queues/rx-0/rps_cpus: nonexistent directory 
call mac80211autochannel for interface: ath0 
sh: can't create /sys/class/net/ath0/queues/tx-0/xps_cpus: nonexistent directory 
freq:2412 qual:71 noise:-89 
freq:2417 qual:40 noise:-89 
freq:2422 qual:65 noise:-90 
freq:2427 qual:70 noise:-90 
freq:2432 qual:45 noise:-90 
freq:2437 qual:94 noise:-90 
freq:2442 qual:48 noise:-91 
freq:2447 qual:73 noise:-91 
freq:2452 qual:73 noise:-91 
freq:2457 qual:49 noise:-92 
freq:2462 qual:91 noise:-92 
freq:2467 qual:50 noise:-92 
freq:2472 qual:75 noise:-92 
mac80211autochannel interface: ath0 frequency: 2437 
setup ath0 E8:DE:27:84:5D:60 
sh: can't create /proc/sys/net/ipv4/netfilter/ip_conntrack_udp_timeouts: nonexistent directory 
No such device 
ZTE generic (cdrom) detected 
customsetup 
Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

Look for default devices ... 
   product ID matched 
 Found devices in default mode (1) 
Access device 002 on bus 001 
Current configuration number is 1 
Use interface number 0 
Use endpoints 0x0a (out) and 0x89 (in) 

USB description data (for identification) 
------------------------- 
Manufacturer: ZTE, Incorporated 
     Product: USB Storage 
  Serial No.: 000000000002 
------------------------- 
Looking for active driver ... 
 No active driver found. Detached before or never attached 
Set up interface 0 
Use endpoint 0x0a for message sending ... 
Trying to send message 1 to endpoint 0x0a ... 
 OK, message successfully sent 
Reset response endpoint 0x89 
Reset message endpoint 0x0a 
 Could not reset endpoint (probably harmless): -99 
 Device is gone, skip any further commands 
-> Run lsusb to note any changes. Bye! 

Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

Look for default devices ... 
 No devices in default mode found. Nothing to do. Bye! 

ath9k radio 0: phy0 ath0 
sh: can't create /proc/sys/dev/wifi0/silent: nonexistent directory 
sh: can't create /proc/sys/dev/wifi0/ledon: nonexistent directory 
ath9k radio 1: phy0 ath0 
sh: can't create /proc/sys/dev/wifi0/silent: nonexistent directory 
/opt/etc/init.d/rcS: No such file or directory 
/jffs/etc/init.d/rcS: No such file or directory 
/mmc/etc/init.d/rcS: No such file or directory 
sh: can't create /proc/sys/net/ipv4/netfilter/ip_conntrack_udp_timeouts: nonexistent directory 
No such device 
ZTE generic (modem) detected 

comment:2 Changed 22 months ago by uruiamme

I wonder if a dmesg output would be informative? Mine show very few difference. I am not sure how to output the serial port log as ashokjp did above. Is there a debugging mode that would help here?

comment:3 Changed 21 months ago by uruiamme

Bugs #4744 and #4066 seem to be the same.

comment:4 Changed 20 months ago by Kong

  • Resolution set to worksforme
  • Status changed from new to closed

Tested current build with Huawei E1750. It is wortking fine with basic config through webif.

Thus cannot reproduce it. If you have problems with a specific device, either supply a fix or a device for testig purposes.

comment:5 Changed 20 months ago by uruiamme

The most recent build is still broken. I tried r27805, tested on Netgear WNDR4300 (v1). WAN connection does not automatically come up during boot like old working r25760. When I click "Connect" on the WAN status page, the page will refresh and no connection is even attempted. I can watch the lights on my Novatel USB760 and see that it is not dialing.

I cannot reproduce a connection, as I do not have a Huawei E1750.

1: I supplied a possible fix.

2: I doubt my USA modem would work in Germany, which I understand is where the developers are located. Furthermore, this is hardly the only modem reported in the forums as not working with builds past r25760.

For example(s), here are independent reports with a lot of different 3G/4G modems:

  1. http://www.dd-wrt.com/phpBB2/viewtopic.php?t=278732&highlight=25760+modem
  1. http://www.dd-wrt.com/phpBB2/viewtopic.php?t=279162&highlight=r25760+modem
  1. http://www.dd-wrt.com/phpBB2/viewtopic.php?t=279412&highlight=25760+modem
  1. http://www.dd-wrt.com/phpBB2/viewtopic.php?t=284227&highlight=25760 (that was me)
  1. http://www.dd-wrt.com/phpBB2/viewtopic.php?t=284646&highlight=25760+modem
  1. http://www.dd-wrt.com/phpBB2/viewtopic.php?p=976349&highlight=r25948+modem#976349
  1. http://www.dd-wrt.com/phpBB2/viewtopic.php?p=977902&highlight=huawei+working#977902
  1. http://www.dd-wrt.com/phpBB2/viewtopic.php?p=981152&highlight=huawei+working#981152

Perhaps something is amiss here? Do you want me to find more reports of broken 3G/4G WAN?

comment:6 Changed 20 months ago by uruiamme

  • Resolution worksforme deleted
  • Status changed from closed to reopened

comment:7 Changed 20 months ago by superunit

Huawei E3272s-153 + dlink-dir632a + r27805 - don't work. r25760 - work fine.

comment:8 Changed 18 months ago by uruiamme

Did anyone try the ifconfig line? Any idea whether 3G/4G modems can be made to work again?

comment:9 Changed 16 months ago by checho

same error exhibited on latest beta from 2016-01-02 on TL-WR842NDv2. Details here: http://www.dd-wrt.com/phpBB2/viewtopic.php?t=288776

Doubt if it's an ifconfig problem because if it were then the ppp0 would appear but stay down. On our case no ppp0 is created but it's not the ifconfig command the one that creates the interfaces. Maybe it's some kernel issue.

comment:10 Changed 16 months ago by GreyDoc

  • Resolution set to wontfix
  • Status changed from reopened to closed

comment:11 Changed 16 months ago by GreyDoc

  • Resolution wontfix deleted
  • Status changed from closed to reopened

same issue on tp-link wr1043nd: http://svn.dd-wrt.com/ticket/5120#comment:2

comment:12 Changed 16 months ago by hackler756

same with Netgear R7000 and Huawei E372 #4963

based on the beta builds, the issue started right after 11-13-2015-r28139

workaroud for me was Kongs Test Build http://www.dd-wrt.com/phpBB2/viewtopic.php?t=286935&highlight=

comment:13 Changed 10 months ago by jcadduono

I have a Sierra AC330 LTE modem that hasn't worked on my R7000 (or R7800) since builds from ~Q3 2015. (Unfortunately data is very expensive so I can't go downloading builds to test without paying very high fees)

The kernel seems to successfully load the driver and all is well until pppd just doesn't work at all to obtain an IP.

Has it gone through any kernel major upgrades? I'm currently running AsusWRT on K2.6 which it seems to work well with.

I've ordered a Huawei E3272s-506 LTE modem in the hopes I might fare better than with the Sierra AC330 one. Will update this comment when it arrives and I can do testing.

Is there anything I can provide for logs to assist with debugging? I'm not familiar with the whole USB debugging and pppd thing, but I do know how to connect via ssh and collect command output :p I'll be idling in the #dd-wrt IRC channel on freenode.

Last edited 10 months ago by jcadduono (previous) (diff)

comment:14 Changed 3 months ago by johnmcm

Has anyone looked into this any further? I have an RT-AC68U with a Sierra AC330U modem as well ... last version that works for me is kong build 28815.

kong ssuggested March 1, 2016 (www.dd-wrt.com/phpBB2/viewtopic.php?t=289777) that it could be because of the newer musl lib used after that point ...

comment:15 Changed 2 months ago by BrainSlayer

i have just a few sticks and they are all working. beside this kong uses the same sourcecodes. so if his builds are working mine will work too

comment:16 Changed 2 months ago by BrainSlayer

  • Resolution set to provide more info and reopen
  • Status changed from reopened to closed

and i see no single usefull info here like at least some logs

comment:17 Changed 2 months ago by Mile-Lile

  • Resolution provide more info and reopen deleted
  • Status changed from closed to reopened

I tested it again. No go.

Feb 18 19:15:48 DD-WRT daemon.info pppd[6674]: Exit.
Feb 18 19:16:22 DD-WRT daemon.notice pppd[6822]: pppd 2.4.7 started by root, uid 0
Feb 18 19:16:22 DD-WRT daemon.info pppd[6822]: Exit.
Feb 18 19:16:57 DD-WRT daemon.notice pppd[6969]: pppd 2.4.7 started by root, uid 0
Feb 18 19:16:57 DD-WRT daemon.info pppd[6969]: Exit.
Feb 18 19:17:31 DD-WRT daemon.notice pppd[7114]: pppd 2.4.7 started by root, uid 0
Feb 18 19:17:31 DD-WRT daemon.info pppd[7114]: Exit.
Feb 18 19:18:05 DD-WRT daemon.notice pppd[7274]: pppd 2.4.7 started by root, uid 0
Feb 18 19:18:06 DD-WRT daemon.info pppd[7274]: Exit.
Feb 18 19:18:40 DD-WRT daemon.notice pppd[7417]: pppd 2.4.7 started by root, uid 0
Feb 18 19:18:40 DD-WRT daemon.info pppd[7417]: Exit.
Feb 18 19:19:14 DD-WRT daemon.notice pppd[7560]: pppd 2.4.7 started by root, uid 0
Feb 18 19:19:14 DD-WRT daemon.info pppd[7560]: Exit.
Feb 18 19:19:49 DD-WRT daemon.notice pppd[7709]: pppd 2.4.7 started by root, uid 0
Feb 18 19:19:49 DD-WRT daemon.info pppd[7709]: Exit.

Changed 2 months ago by Mile-Lile

comment:18 Changed 2 months ago by Mile-Lile

and there are logs from serial UART if it helps... Look at the top of bug report...

comment:19 Changed 2 months ago by stalonge

I have here a Linksys E3000 with 25527 .. This is my last working build for 4G modem Huawei E3276 and Huawei E392 .. I have tried to work with these modem since 25527 .. no go ..

I want to plug these modems in a r7000 ... no success

Note: See TracTickets for help on using tickets.